<template>
  <div>
    <label id="listbox-label" class="block text-sm font-medium text-gray-700">
      {{ label }}
    </label>
    <div class="mt-1 relative">
      <appSelectSelected @click="open = true" @blur="handleBlur">
        {{ text(selectedItem) }}
      </appSelectSelected>
      <div class="app-input__details mt-0.5">
        <transition name="fade">
          <p v-show="inputError" class="text-red-500 text-xs italic">
            {{ errorMessage || errorMessageLocal }}
          </p>
        </transition>
      </div>
      <ul
        v-show="open"
        class="absolute z-10 -mt-3.5 w-full bg-white shadow-lg max-h-56 rounded-md py-1 text-base ring-1 ring-black ring-opacity-5 overflow-auto focus:outline-none sm:text-sm"
        tabindex="-1"
        role="listbox"
        aria-labelledby="listbox-label"
      >
        <appSelectItem
          v-for="(item, index) in items"
          :key="index"
          :selected="itemIsSelected(item)"
          @select="handleItemSelect(item)"
          @mousedown="handleItemMouseDown"
        >
          {{ text(item) }}
        </appSelectItem>
      </ul>
    </div>
  </div>
</template>

<script>
export default {
  name: 'appSelect',
  props: {
    value: { type: [Number, String], default: () => [] },
    items: { type: Array, default: () => [] },
    itemText: { type: String, default: 'text' },
    rules: { type: [Array], default: () => [] },
    label: { type: String, default: '' },
    errorMessage: { type: String, default: null },
    itemValue: { type: String, default: 'value' },
  },
  data: () => ({
    open: false,
    timer: null,
    errorMessageLocal: '',
  }),
  computed: {
    inputError() {
      return !!this.errorMessageLocal || !!this.errorMessage;
    },
    selectedItem() {
      return (
        this.items.find((item) => {
          return item[this.itemValue] === this.value;
        }) || {}
      );
    },
  },
  watch: {
    open(val) {
      if (!val) {
        this.validate();
      }
    },
  },
  methods: {
    validate() {
      this.$nextTick(() => {
        const length = (this.rules || []).length;
        for (let i = 0; i < length; i++) {
          const validateRule = this.rules[i](this.value);
          if (typeof validateRule === 'string') {
            this.errorMessageLocal = validateRule;
            return;
          }
        }
        this.errorMessageLocal = '';
      });
    },
    itemIsSelected(item) {
      return item.id === this.selectedItem.id;
    },
    text(item) {
      return item[this.itemText];
    },
    valueOfItem(item) {
      return item[this.itemValue];
    },
    handleItemMouseDown() {
      this.timer = true;
    },
    handleItemSelect(item) {
      this.$emit('input', this.valueOfItem(item));

      this.open = false;
    },
    handleBlur() {
      if (this.timer) {
        this.timer = null;
        return;
      }
      setTimeout(() => {
        this.open = false;
      }, 100);
    },
  },
};
</script>

<style></style>
